// (C) 2006 Jean-Francois Nifenecker - jean-francois.nifenecker@laposte.net
//
// -----------------------------------------------------------------------------
// LICENSE
// This software is released under the terms of the GNU LGPL.
// For more information, see the attaxhed License.txt file
// or http://www.gnu.org/licenses/lgpl.html
// -----------------------------------------------------------------------------
//
unit DisplayMsg;

interface

procedure Display(const aStr: string);

procedure DisplayLn(const aStr: string = '');

procedure DisplayError(const aErrorStr: string);

procedure DisplayHeader;

procedure DisplayHelp;


// =============================================================================
implementation

uses
  // Application
  Globals,
  Options
  ;


procedure Display(const aStr: string);
begin
if not g_Options[optQuiet].Enabled then Write(aStr);
end;// Display

procedure DisplayLn(const aStr: string = '');
begin
if not g_Options[optQuiet].Enabled then WriteLn(aStr);
end;// Display

procedure DisplayError(const aErrorStr: string);
begin
DisplayLn('Error: ' + aErrorStr);
end;// DisplayError

procedure DisplayHelp;

begin
DisplayHeader;
DisplayLn('Syntax: ' + CmdShortName + ' [filespec] [-Q] [-F<FileName>] [-X<FileExt>] [+B | -B] [+E | -E]');
DisplayLn;
DisplayLn('Options');
DisplayLn('  filespec = File name(s) to process');
DisplayLn('  -? or -H = Show this help page');
DisplayLn('  -Q = Quiet');
DisplayLn('  -F<FileName> = File name containing the file list to process (one per line)');
DisplayLn('  -X<FileExt>  = Backup extension (without dot)');
DisplayLn;
DisplayLn('Switches [default]');
DisplayLn('  + = On');
DisplayLn('  - = Off');
DisplayLn('  B = Backup existing files [+]');
DisplayLn('  E = Halt on errors [-]');
DisplayLn;
end;// DisplayHelp

procedure DisplayHeader;
begin
DisplayLn(CmdName + ' ' + CmdVer + ' ' + CmdCopyright);
DisplayLn('');
end;// DisplayHeader

end.
