unit FileUtils;

interface

uses
  // Delphi
  Classes
  ;

function BuildFileList
  (
  const aPath: string;
  const aAttr: Integer;
  const aList: TStrings
  ): Boolean;


//==============================================================================
// (C) 2006 Jean-Francois Nifenecker - jean-francois.nifenecker@laposte.net
//
// -----------------------------------------------------------------------------
// LICENSE
// This software is released under the terms of the GNU LGPL.
// For more information, see the attaxhed License.txt file
// or http://www.gnu.org/licenses/lgpl.html
// -----------------------------------------------------------------------------
//
implementation

uses
  // Delphi
  SysUtils, Windows
  ;

function BuildFileList
  (
  const aPath: string;
  const aAttr: Integer;
  const aList: TStrings
  ): Boolean;

var
  l_SR      : TSearchRec;
  l_FileRec : Integer;

begin
Assert(aList <> nil);

l_FileRec := FindFirst(aPath, aAttr, l_SR);
Result    := (l_FileRec = 0);

aList.BeginUpdate;
try
  if Result then
  begin
    while (l_FileRec = 0) do
      begin
      if (l_SR.Name <> '.') and (l_SR.Name <> '..')
      then
        begin
        aList.Add(l_SR.Name);
        end;

      l_FileRec := FindNext(l_SR);
      end;// while
    Result := (l_FileRec = ERROR_NO_MORE_FILES);
  end;
finally
  SysUtils.FindClose(l_SR);
  aList.EndUpdate;
end;// try
end;// BuildFileList

end.
